// Copyright 2019 github.com. All rights reserved.
// Use of this source code is governed by github.com.

package consts

const (
	PageSize = 10
)


const (
	TimeSecondLayOut = "2006-01-02 15:04:05"
)

const (
	_ = iota
	AttendanceKindIn
	AttendanceKindOut
	AttendanceKindInOut
	AttendanceKindCollect
)

const (
	_ = iota
	AttendanceSubKindIris
	AttendanceSubKindRedFace
	AttendanceSubKindLightFace
	AttendanceSubKindLightRedFace
	AttendanceSubKindLightFaceIris
)

var AttendanceKind = map[int]string{
	AttendanceKindIn:"进场设备",
	AttendanceKindOut:"出场设备",
	AttendanceKindInOut:"进出场设备",
	AttendanceKindCollect:"采集设备",
}

var AttendanceSubKind = map[int]string{
	AttendanceSubKindIris:"虹膜设备",
	AttendanceSubKindRedFace:"红外人脸设备",
	AttendanceSubKindLightFace:"可见光人脸设备",
	AttendanceSubKindLightRedFace:"可见光+红外人脸设备",
	AttendanceSubKindLightFaceIris:"可见光+虹膜设备",
}
const (
	DeviceStatusAddAuditting = iota //添加设备待审核
	DeviceStatusAddAuditted//添加设备审核通过
	DeviceStatusAddAudittedFail//添加设备审核未通过

)

const (
	DeviceTypeStatusAddTesting = iota //添加设备类型待对接测试
	DeviceTypeStatusAddTestted //对接测试通过
	DeviceTypeStatusAddTesttedFail //对接测试未通过

)
const (
	DeviceTypeStatusAddAuditting = iota // 待住建部审批
	DeviceTypeStatusAddAuditted //住建部审核通过
	DeviceTypeStatusAddAudittedFail //住建部审核未通过
)

const (
	ProviderStatusAddAuditting = iota
	ProviderStatusAddAuditted
	ProviderStatusAddAudittedFail
)

const (
	CompanyStatusAddAuditting = iota
	CompanyStatusAddAuditted
	CompanyStatusAddAudittedFail
)

const (
	ProjectStatusAddAuditting = iota
	ProjectStatusAddAuditted
	ProjectStatusAddAudittedFail
)

const (
	_ = iota
	ProjectUserTypeConstruction //建设
	ProjectUserTypeProject //项目
	ProjectUserTypeSupervision //监理
)

// 项目类别
const (
	ProjectCategoryHouse = 1
	ProjectCategoryCity = 2
	ProjectCategoryOther = 99
)

var ProjectCategoryM = map[uint32]string{
	ProjectCategoryHouse:"房屋建筑工程",
	ProjectCategoryCity:"市政工程",
	ProjectCategoryOther:"其他",
}

// 建设性质
const (
	ProjectConstructTypeBuild = 1
	ProjectConstructTypeChange = 2
	ProjectConstructTypeIncrease = 3
)

var ProjectConstructTypeM = map[uint32]string{
	ProjectConstructTypeBuild:"新建",
	ProjectConstructTypeIncrease:"扩建",
	ProjectConstructTypeChange:"改建",
}

// 项目状态
const (
	ProjectStatusPrepare = 1
	ProjectStatusApproval = 2
	ProjectStatusBuilding = 3
	ProjectStatusFinish = 4
	ProjectStatusStop = 5
)

var ProjectStatusM = map[uint32]string{
	ProjectStatusPrepare:"筹备",
	ProjectStatusApproval:"立项",
	ProjectStatusBuilding:"在建",
	ProjectStatusFinish:"完工",
	ProjectStatusStop:"停工",
}

// 参建单位
const (
	ProjectCorpProfesional = 1
	ProjectCorpDevice = 2
	ProjectCorpMaterial = 3
	ProjectCorpLogistics = 4
	ProjectCorpSpecialDevice = 5
	ProjectCorpLabor = 6
	ProjectCorpSupervisor = 7
	ProjectCorpConstruction = 8
	ProjectCorpContract = 9

	ProjectCorpInvestigation = 10
	ProjectCorpDesign = 11
	ProjectCorpOther = 12
)

var ProjectCorpM = map[uint32]string{
	ProjectCorpProfesional:"专业分包",
	ProjectCorpDevice :"设备分包",
	ProjectCorpMaterial :"材料分包",
	ProjectCorpLogistics :"后勤服务",
	ProjectCorpSpecialDevice :"特殊设备",
	ProjectCorpLabor :"劳务分包",
	ProjectCorpConstruction:"建设单位",
	ProjectCorpContract:"总承包单位",
	ProjectCorpSupervisor:"监理单位",
	ProjectCorpInvestigation:"勘察单位",
	ProjectCorpDesign:"设计单位",
	ProjectCorpOther:"其他",
}

// 人员编码
const (
	StaffTypeChiefSupervisor = 1001
	StaffTypeDeputyChiefSupervisor = 1002
	StaffTypeSafetyChiefSupervisor = 1003
	StaffTypeProfessionalSupervisor = 1004
	StaffTypeNormalSupervisor = 1005
	StaffTypeSupervisor = 1006
	StaffTypeSupervisorSafty = 1007
	StaffTypeBigEngineer = 1008
	StaffTypeManager = 1009
	StaffTypeEngineerManager = 1010
	StaffTypeTechnical = 1011
	StaffTypeEngineer = 1012
	StaffTypeAdmin = 1013
	StaffTypeDeputyManager = 1014
	StaffTypeChiefInspector = 1015
	StaffTypeConstructor = 1016
	StaffTypeQuality = 1017
	StaffTypeSafety = 1018
	StaffTypeStandard = 1019
	StaffTypeMaterial = 1020
	StaffTypeMachine = 1021
	StaffTypeLabor = 1022
	StaffTypeData = 1023
	StaffTypeChiefSupervisorDelegate = 1024
	StaffTypeMeasure = 1025
	StaffTypeTester = 1026
	StaffTypeCost = 1027
	StaffTypeQualityResponsible = 1028
	StaffTypeSafetyResponsible = 1029
	StaffTypeTechnicalResponsible = 1030
	StaffTypeProduceManager = 1031
	StaffTypeSourceManager = 1032
	StaffTypeOther = 1099


)

var StaffTypeM = map[uint32]string{
	StaffTypeChiefSupervisor: "总监理工程师",
	StaffTypeDeputyChiefSupervisor : "副总监理工程师",
	StaffTypeSafetyChiefSupervisor: "安全监理工程师",
	StaffTypeProfessionalSupervisor: "专业监理工程师",
	StaffTypeNormalSupervisor: "监理工程师",
	StaffTypeSupervisor: "监理员",
	StaffTypeSupervisorSafty: "监理安全员",
	StaffTypeBigEngineer : "项目总工程师",
	StaffTypeManager : "项目经理",
	StaffTypeEngineerManager : "工程经理",
	StaffTypeTechnical: "项目技术负责人",
	StaffTypeEngineer : "项目工程师",
	StaffTypeAdmin : "项目管理员",
	StaffTypeDeputyManager : "项目副经理",
	StaffTypeChiefInspector : "项目总监",
	StaffTypeConstructor : "施工员",
	StaffTypeQuality : "质量员",
	StaffTypeSafety : "安全员",
	StaffTypeStandard : "标准员",
	StaffTypeMaterial : "材料员",
	StaffTypeMachine : "机械员",
	StaffTypeLabor : "劳务员",
	StaffTypeData: "资料员",
	StaffTypeChiefSupervisorDelegate : "总监理工程师代表",
	StaffTypeMeasure : "测量员",
	StaffTypeTester : "试验员",
	StaffTypeCost : "造价员",
	StaffTypeQualityResponsible : "质量负责人",
	StaffTypeSafetyResponsible : "安全负责人",
	StaffTypeTechnicalResponsible : "技术负责人",
	StaffTypeProduceManager : "生产经理",
	StaffTypeSourceManager : "物质材料工程师",
	StaffTypeOther : "其他",
}

// 证件类型
const (
	CertTypeID = 1
	CertTypePassport = 2
)
var CertTypeM = map[uint32]string{
	CertTypeID:"身份证",
	CertTypePassport:"护照",
}

// 设备状态字典
const (
	DeviceStateNormal = 1
	DeviceStateDel = 2
	DeviceStateOff = 3
)
var DeviceStateM = map[uint32]string{
	DeviceStateNormal:"正常",
	DeviceStateDel:"已拆机",
	DeviceStateOff:"暂停维护",
}

// 扬尘数据类型
const (
	DustDataTypeRealTime = iota
	DustDataTypeMinute
	DustDataTypeHour
	DustDataTypeDay
	DustDataTypeNight
	DustDataTypeTotalDay
	DustDataTypeMonth
	DustDataTypeYear
	DustDataType20Minute
)

var ProvincialVerifyStatus = map[int32]string{
	0:"暂未验证",
	204:"验证结束",
	203:"正在验证",
	205:"等候验证",
	201:"开始处理数据",
}
var ProvincialVerifyResult = map[int32]string{
	0:"成功",
	1:"失败",
}