// Copyright 2019 github.com. All rights reserved.
// Use of this source code is governed by github.com.

package errors

import (
	"google.golang.org/grpc/status"
)

var (
	// 通用错误
	SystemError   = status.Error(10001, "系统错误")
	ServiceError  = status.Error(10002, "内部服务错误")
	ParamsError   = status.Error(10003, "参数错误")
	DataBaseError = status.Error(10004, "数据库错误")
	NoRecordError = status.Error(10005, "查无记录")

	//
	UserPassError = status.Error(20001, "用户密码错误")
	UserNotExistError = status.Error(20002, "用户不存在")
	UserExistError = status.Error(20003, "用户已存在")

	ProjectExistError = status.Error(20004, "项目已存在")
	ProjectNotExistError = status.Error(20005, "项目不存在")

	DeviceExistError = status.Error(20006, "设备已存在")
	DeviceNotExistError = status.Error(20007, "设备不存在")

	ProjectNotMatchError = status.Error(20008, "项目不匹配")

	UserStatusError = status.Error(20009, "用户状态错误")
	DeviceTypeNotExistError = status.Error(20010, "设备类型不存在")
	DeviceAddCheckError = status.Error(20011, "设备未对接或未审批")
	DeviceDelStatusError = status.Error(20012, "设备当前状态不能拆机")
	VssStatusError = status.Error(20014, "视频状态不支持该操作")
	ProjectFinishError = status.Error(20015, "有项目进度未完工，请先在项目后台设置项目进度")

	EmailExist = status.Error(20023, "邮箱已存在")
	PhoneExist = status.Error(20024, "电话号码已存在")
	ProjectDelError = status.Error(20025, "删除项目前请先拆机")
	ProvincialFailed = status.Error(20026, "省厅接口调用失败")
	ProvincialVerifyError = status.Error(20027, "省厅正在验证数据")

)
