// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package device

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
	"smart-enterprise-management/errors"
	"smart-enterprise-management/model"
	"smart-enterprise-management/pb/v1"
)

func DeviceAllTypeList(ctx context.Context, req *v1.DeviceAllTypeListRequest) (reply *v1.DeviceAllTypeListReply, err error) {
	reply = &v1.DeviceAllTypeListReply{}
	p := &model.TDeviceTypeItem{}
	m, _, err := p.AllMap(database.DB())
	if err != nil {
		logger.Error("DeviceAllTypeList",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	// 获取总的设备类型列表
	reply.List = make([]*v1.DeviceAllTypeItem, len(m))
	i := 0
	for code, name := range m {
		item := &v1.DeviceAllTypeItem{
			TypeName: name,
			TypeCode: code,
		}
		reply.List[i] = item
		i++
	}
	return reply, nil
}
