package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"go.uber.org/zap"
	"smart-enterprise-management/pb"
	"smart-enterprise-management/model"
	"smart-enterprise-management/pb/v1"
	"time"
	"github.com/jaryhe/gopkgs/logger"
)

func ProvincialTask() {
	project := model.ProjectInfo{}
	where := map[string]interface{}{
		"ProvincialVerifyStatus !=": 204,
		"ProvincialVerifyStatus is":"NULL",
	}
	page := int32(0)
	for {
		list, _ := project.List(database.DB(), nil, where,  page, 10)
		for _, v := range list {
			if v.ProvincialVerifyID == "" {
				continue
			}
			mreq := v1.ProvincialVerifyDataRequest{Id:v.ProvincialVerifyID}
			mreply, err := pb.Provincial.ProvincialVerifyData(context.Background(), &mreq)

			if err != nil {
				logger.Error("ProvincialTask",
					zap.String("call", "pb.Thirdparty.ProvincialVerifyData"),
					zap.String("param", v.ProvincialVerifyID),
					zap.String("error",err.Error()))
				time.Sleep(1*time.Second)
				continue
			}
			p := model.ProjectInfo{}
			where := map[string]interface{}{
				"ID": v.ID,
			}
			values := map[string]interface{}{
				"ProvincialVerifyStatus":mreply.State,
				"ProvincialVerifyCode":mreply.Result,
				"ProvincialVerifyInfo":mreply.AllMessage,
			}
			err = p.Update(database.DB(), where, values)
			logger.Error("ProvincialTask",
				zap.String("mysql", "update"),
				zap.String("error",err.Error()))
			time.Sleep(1*time.Second)
		}
		if len(list) < 10 {
			page = 0
			time.Sleep(30*time.Second)
			continue
		}
		page += 1
	}

}
