// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package project

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
	"smart-enterprise-management/errors"
	"smart-enterprise-management/model"
	"smart-enterprise-management/pb/v1"
	"time"
)

func ProjectUserPasswordReset(ctx context.Context, req *v1.ProjectUserPasswordResetRequest) (reply *v1.ProjectUserPasswordResetReply, err error) {
	if req.Id == 0 || req.Password == ""{
		return nil, errors.ParamsError
	}
	now := time.Now()
	reply = &v1.ProjectUserPasswordResetReply{}
	p := model.TSiteUser{}
	where := map[string]interface{}{
		"id":          req.Id,
	}
	err = p.Find(database.DB(), where, nil)
	if err != nil {
		return nil, errors.DataBaseError
	}
	if p.Id == 0 {
		return nil, errors.NoRecordError
	}
	newPass, err := getB64Pass(req.Password)
	if err != nil {
		return nil, errors.SystemError
	}
	value := map[string]interface{}{
		"Passwd":newPass,
		"UpdatedAt":now,
	}
	err = p.Update(database.DB(), where, value)
	if err != nil {
		logger.Error("ProjectAdd",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	return reply, nil

}
