// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package user

import (
	"context"
	"smart-enterprise-management/consts"
	dbmodel "smart-enterprise-management/model"
	"smart-enterprise-management/errors"
	pb_v1 "smart-enterprise-management/pb/v1"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jinzhu/gorm"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
)

func Login(ctx context.Context, req *pb_v1.LoginRequest)(reply *pb_v1.LoginReply, err error) {
	if req.User == "" || req.Password == "" {
		return nil, errors.ParamsError
	}
	p := dbmodel.TCompany{}
	where := map[string]interface{}{"UserName":req.User, "Status":consts.CompanyStatusAddAuditted}
	err = p.Find(database.DB(), where, nil)
	if err != nil && err != gorm.ErrRecordNotFound {
		logger.Error("Login",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id == 0 {
		return nil, errors.UserNotExistError
	}
	pass,_ := getMd5Pass(req.Password)
	if pass != p.Passwd {
		logger.Error("Login",
			zap.String("err", "password error"))
		return nil, errors.UserPassError
	}
	reply = &pb_v1.LoginReply{
		Uid:p.Id,
	}
	return reply, nil
}
