// Copyright 2019  githup.com. All rights reserved.
// Use of this source code is governed by  githup.com.
package user

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jaryhe/gopkgs/logger"
	"github.com/jinzhu/gorm"
	"go.uber.org/zap"
	"smart-enterprise-management/errors"
	dbmodel "smart-enterprise-management/model"
	pb_v1 "smart-enterprise-management/pb/v1"
	"time"
)

func PhoneUpdate(ctx context.Context, req *pb_v1.PhoneUpdateRequest)(reply *pb_v1.PhoneUpdateReply, err error) {
	p := &dbmodel.TCompany{}
	where := map[string]interface{}{
		"BusinessContactPhone":req.Phone,
	}
	// 状态判断
	err = p.Find(database.DB(), where, nil)
	if err != nil && err != gorm.ErrRecordNotFound{
		logger.Error("PhoneUpdate",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id > 0 {
		return nil, errors.PhoneExist
	}

	p = &dbmodel.TCompany{}
	where = map[string]interface{}{
		"ID":req.Id,
	}
	// 状态判断
	err = p.Find(database.DB(), where, nil)
	if err != nil {
		logger.Error("PhoneUpdate",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id == 0 {
		return nil, errors.NoRecordError
	}
	reply = &pb_v1.PhoneUpdateReply{}

	values := map[string]interface{}{
		"BusinessContactPhone":req.Phone,
		"UpdatedAt":time.Now(),
	}
	err = p.Update(database.DB(), where, values)
	if err != nil {
		return nil, errors.DataBaseError
	}

	return reply, nil
}
