package user

import (
	"context"
	"github.com/jaryhe/gopkgs/database"
	"github.com/jinzhu/gorm"
	"smart-enterprise-management/consts"
	"smart-enterprise-management/errors"
	dbmodel "smart-enterprise-management/model"
	"smart-enterprise-management/pb/v1"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"
)

func SetPasswd(ctx context.Context, req *v1.SetPasswdRequest) (reply *v1.SetPasswdReply, err error) {

	p := &dbmodel.TCompany{}

	and := map[string]interface{}{
		"Status":                 consts.ProviderStatusAddAuditted,
		"BusinessContactPhone": req.Phone,
	}

	err = p.Find(database.DB(), and, nil)
	if err != nil && err != gorm.ErrRecordNotFound {
		logger.Error("SetPasswd",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}
	if p.Id == 0 {
		return nil, errors.UserNotExistError
	}

	where := map[string]interface{}{
		"ID": p.Id,
	}
	p.Passwd, err = getMd5Pass(req.Passwd)
	if err != nil {
		logger.Error("SetPasswd",
			zap.String("err", err.Error()))
		return nil, errors.SystemError
	}
	err = p.Update(database.DB(), where, map[string]interface{}{"Passwd": p.Passwd})
	if err != nil {
		logger.Error("SetPasswd",
			zap.String("err", err.Error()))
		return nil, errors.DataBaseError
	}

	return &v1.SetPasswdReply{}, nil
}
