// Copyright 2019 github.com. All rights reserved.
// Use of this source code is governed by github.com.

package model

import (
	"encoding/json"
	"time"

	"github.com/jaryhe/gopkgs/logger"
	"github.com/jinzhu/gorm"
	"go.uber.org/zap"
)

type TAlarm struct {
	Id          int64  `gorm:"column:ID;primary_key"`
	ProjectId   int64  `gorm:"column:ProjectId"`
	Sn          string `gorm:"column:SN"`
	AlarmCode   string `gorm:"column:AlarmCode"`
	AlarmReason string `gorm:"column:AlarmReason"`
	IsHandle    bool   `gorm:"column:IsHandle"`
	Time        time.Time `gorm:"column:Time"`
	CreatedAt   string `gorm:"column:CreatedAt"`
	UpdatedAt   string `gorm:"column:UpdatedAt"`
}

func (TAlarm) TableName() string {
	return "Alarm"
}

func (p *TAlarm) Delete(db *gorm.DB, filter map[string]interface{}) error {
	err := db.Table(p.TableName()).Where(filter).Delete(p).Error
	if err != nil {
		fields, _ := json.Marshal(filter)
		logger.Error("mysql",
			zap.String("sql", "delete from t_alarm"),
			zap.String("fields", string(fields)),
			zap.String("error", err.Error()))
		return err
	}
	return nil
}
