// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package model

import (
	"encoding/json"
	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"

	"github.com/jinzhu/gorm"
)

type TAlarmContact struct {
	Id        uint64 `gorm:"column:ID;primary_key"`
	ProjectId int64  `gorm:"column:ProjectId"`
	Phone     string `gorm:"column:Phone"`
	Email     string `gorm:"column:Email"`
	CreatedAt string `gorm:"column:CreatedAt"`
	UpdatedAt string `gorm:"column:UpdatedAt"`
}

func (TAlarmContact) TableName() string {
	return "AlarmContact"
}



func (p *TAlarmContact) Delete(db *gorm.DB, filter map[string]interface{}) error {
	err := db.Table(p.TableName()).Where(filter).Delete(p).Error
	if err != nil {
		fields, _ := json.Marshal(filter)
		logger.Error("mysql",
			zap.String("sql", "delete from t_alarm_contact"),
			zap.String("fields", string(fields)),
			zap.String("error", err.Error()))
	}
	return err
}
