// Copyright 2019  github.com. All rights reserved.
// Use of this source code is governed by  github.com.
package model

import (
	"encoding/json"

	"github.com/jaryhe/gopkgs/logger"
	"go.uber.org/zap"

	"github.com/jinzhu/gorm"
)

type TAlarmRule struct {
	Id             int64  `gorm:"column:ID;primary_key"`
	ProjectId      int64  `gorm:"column:ProjectId"`
	Sn             string `gorm:"column:SN"`
	ContinuePeriod int32  `gorm:"column:ContinuePeriod"`
	AlarmCount     int32  `gorm:"column:AlarmCount"`
	SilencePeriod  int32  `gorm:"column:SilencePeriod"`
	IsOn           bool   `gorm:"column:IsOn"`
	CreatedAt   string `gorm:"column:CreatedAt"`
	UpdatedAt   string `gorm:"column:UpdatedAt"`
}

func (TAlarmRule) TableName() string {
	return "AlarmRule"
}



func (p *TAlarmRule) Delete(db *gorm.DB, filter map[string]interface{}) error {
	err := db.Table(p.TableName()).Where(filter).Delete(p).Error
	if err != nil {
		fields, _ := json.Marshal(filter)
		logger.Error("mysql",
			zap.String("sql", "delete from t_alarm_rule"),
			zap.String("fields", string(fields)),
			zap.String("error", err.Error()))
	}
	return err
}

