package model

import (
	"github.com/jinzhu/gorm"
	"time"
)

type DustExcessiveInfo struct {
	ID int64 `gorm:"column:ID"`
	Code string `gorm:"column:Code"`
	Name string `gorm:"column:Name"`
	DeviceID string `gorm:"column:DeviceID"`
	MonitoringTime time.Time `gorm:"column:MonitoringTime"`
	Pm10EValue float64 `gorm:"column:Pm10EValue"`
	Pm25EValue float64 `gorm:"column:Pm25EValue"`
	Voice float64 `gorm:"column:Voice"`
	Ecode string `gorm:"column:Ecode"`
	ProjectId int64 `gorm:"column:ProjectId"`
	SN string `gorm:"column:SN"`
}

func (DustExcessiveInfo) TableName() string {
	return "DustExcessiveInfo"
}

func (p *DustExcessiveInfo) Insert(db *gorm.DB) error {
	return db.Table(p.TableName()).Create(p).Error
}

func (p *DustExcessiveInfo) Find(db *gorm.DB, where map[string]interface{}, or map[string]interface{}) error {
	cond, val, err := whereBuildAndOr(where, or)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).First(p).Error
}


func (p *DustExcessiveInfo) All(db *gorm.DB, where map[string]interface{}) (list []DustExcessiveInfo, err error) {

	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return nil, err
		}
		result := db.Table(p.TableName()).Where(cond, val).Find(&list)
		return list, result.Error
	}
	result := db.Table(p.TableName()).Find(&list)

	return list, result.Error
}

func (p *DustExcessiveInfo) Count(db *gorm.DB, where map[string]interface{}) (int64, error) {
	if len(where) > 0 {
		cond, val, err := whereBuild(where)
		if err != nil {
			return 0, err
		}
		ret := int64(0)
		err = db.Table(p.TableName()).Where(cond, val...).Count(&ret).Error

		return ret, err
	}
	ret := int64(0)
	err := db.Table(p.TableName()).Count(&ret).Error
	return ret, err
}

func (p *DustExcessiveInfo) Del(db *gorm.DB, where map[string]interface{}) error {
	cond, val, err := whereBuild(where)
	if err != nil {
		return err
	}
	return db.Table(p.TableName()).Where(cond, val...).Delete(p).Error
}

